package com.poto.timeservice;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import com.poto.timeservice.Model.PoMemberModel;

import java.util.ArrayList;

/*tableView Adapter*/
public class PotMainAdapter extends RecyclerView.Adapter<PotMainAdapter.PotViewHolder> {
    private final LayoutInflater layout;
    private final Context theContext;
    private final ArrayList<PoMemberModel> dataSource;

    public PotMainAdapter(Context context) {
        layout = LayoutInflater.from(context);
        theContext = context;

        dataSource = new ArrayList<>();
        for (int i = 0; i < 3; i++) {
            PoMemberModel member = new PoMemberModel();
            member.setName("Poto" + Integer.toString(i));
            member.setTel("1560123");
            member.setAddress("罗家村");
            dataSource.add(member);
        }
    }

    @Override
    public PotMainAdapter.PotViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        return new PotViewHolder(layout.inflate(R.layout.activity_po_root_item_cell, parent, false));
    }

    @Override
    public void onBindViewHolder(final PotMainAdapter.PotViewHolder holder, int pos) {
        PoMemberModel member = dataSource.get(pos);
        holder.nameLab.setText(member.getName());
        holder.telLab.setText(member.getTel());
        /*地址*/
        holder.displayDetailAddr(member.getProv(), member.getCity(), member.getArea(), member.getAddress());
    }

    @Override
    public int getItemCount() {
        return dataSource == null ? 0 : dataSource.size();
    }

    /*数据操作*/
    public void addObject(PoMemberModel member) {
        dataSource.add(member);
        notifyItemInserted(dataSource.size() - 1);
    }

    public void removeObject(int pos) {
        dataSource.remove(pos);
        notifyItemRemoved(pos);
    }

    /*view*/
    static class PotViewHolder extends RecyclerView.ViewHolder {
        /*姓名*/
        TextView nameLab;
        /*电话*/
        TextView telLab;
        /*详细地址*/
        TextView addrLab;

        PotViewHolder(View itemView) {
            super(itemView);
            nameLab = itemView.findViewById(R.id.nameLab);
            telLab = itemView.findViewById(R.id.telLab);
            addrLab = itemView.findViewById(R.id.addrLab);
        }

        /*设置详细地址*/
        public void displayDetailAddr(String prov, String city, String area, String addr) {
            String str = " 详细地址：" + PoCommon.checkNull(prov) + PoCommon.checkNull(city) + PoCommon.checkNull(area) + PoCommon.checkNull(addr);
            addrLab.setText(str);
        }
    }
}